Bug 977971 - Automount not recognizing intr option
Automount not recognizing intr option
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: autofs (Show other bugs)
18
x86_64 Linux
unspecified Severity medium
: ---
: ---
Assigned To: Ian Kent
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-25 13:12 EDT by G. Michael Carter
Modified: 2014-02-05 16:57 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 16:57:40 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description G. Michael Carter 2013-06-25 13:12:57 EDT
autofs.x86_64: 5.0.7-16.fc18

Description of problem:

I have automount connecting to various drives over VPN.  The VPN server is set to timeout after 24 hours and there's nothing I can do about that.

Every once and a while the NFS locks.  Which causes df, and other commands just to hang.  This eventually locks gnome-shell.

The suggestion I've had from our Linux experts is to add the intr option to the NFS mounts.

Here's my latest attempts to get the option in there:

/net  -hosts  tcp,intr,nolock,timeo=600,soft -intr --timeout=3600

I see the soft and timeo in the /etc/mtab but, with everything I try, intr is nowhere to be found.

Is there another place to put it or is this a bug?
Comment 1 Ian Kent 2013-06-25 21:58:04 EDT
(In reply to G. Michael Carter from comment #0)
> autofs.x86_64: 5.0.7-16.fc18
> 
> Description of problem:
> 
> I have automount connecting to various drives over VPN.  The VPN server is
> set to timeout after 24 hours and there's nothing I can do about that.
> 
> Every once and a while the NFS locks.  Which causes df, and other commands
> just to hang.  This eventually locks gnome-shell.
> 
> The suggestion I've had from our Linux experts is to add the intr option to
> the NFS mounts.

What do you expect to get from that?
Are you expecting to be able to interrupt these commands from the
keyboard?

I don't see how that will help (even if you could interrupt the
process from the keyboard) since you won't be able to do that
for non-interactive processes.

I believe the reason that NFS is so stubborn in these cases is
because it tryies very hard to avoid possible file system
corruption. NFS isn't going to give up easily on IO to a server
when it goes away. That's been a problem for many years and isn't
likely to change.

> 
> Here's my latest attempts to get the option in there:
> 
> /net  -hosts  tcp,intr,nolock,timeo=600,soft -intr --timeout=3600
> 
> I see the soft and timeo in the /etc/mtab but, with everything I try, intr
> is nowhere to be found.
> 
> Is there another place to put it or is this a bug?

You don't need to pass the intr option when using the internal
hosts map. It is always set in the options string unless nointr
is explicitly given.

You can verify that yourself by setting LOGGING="debug" in
/etc/sysconfig/autofs and ensuring that daemon.debug (I usually
just use daemon.*) is being logged in syslog. You should see
the mount command, including the options, used in the log.

This article might be worth reading (I only glimpsed at it
myself).

http://www.ibm.com/developerworks/linux/library/l-task-killable

IIRC when I had a look at task killable related patches (long
ago) it occurred to me that they would require a SIGKILL to
interrupt an NFS request. 

I think one consequence of the task killable changes is that
the kernel is ignoring intr (and nointr) since they no longer
make sense. I believe you need to explicitly send a SIGKILL
to processes blocked like this to get them to give up on the
NFS IO.

In the kernel NFS client you can see:

static const match_table_t nfs_mount_option_tokens = {
....

        { Opt_deprecated, "intr" },
        { Opt_deprecated, "nointr" },
...
};

and later:

static int nfs_parse_mount_options(char *raw,
                                   struct nfs_parsed_mount_data *mnt)
{
...
                case Opt_userspace:
                case Opt_deprecated:
                        dfprintk(MOUNT, "NFS:   ignoring mount option "
                                        "'%s'\n", p);
                        break;
...
)
Comment 2 Fedora End Of Life 2013-12-21 09:08:36 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 3 Fedora End Of Life 2014-02-05 16:57:40 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.